/*
    AQTRONIX C++ Library
    Copyright 2005-2006 Parcifal Aertssen

    This file is part of AQTRONIX C++ Library.

    AQTRONIX C++ Library is free software; you can redistribute it
	and/or modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2 of
	the License, or (at your option) any later version.

    AQTRONIX C++ Library is distributed in the hope that it will be
	useful, but WITHOUT ANY WARRANTY; without even the implied warranty
    of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with AQTRONIX C++ Library; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
    MA  02111-1307  USA
*/
// Clipboard.cpp: implementation of the CClipboard class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Clipboard.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

/*
 * 2006.02.10 Class created
 */

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CClipboard::CClipboard():IsOpen(false)
{

}

CClipboard::~CClipboard()
{

}

bool CClipboard::Open()
{
	//open clipboard
	if(!IsOpen){
		if(OpenClipboard(NULL)){
			IsOpen=true;
			return true;
		}else{
			return false;
		}
	}else{
		return false;
	}
}

bool CClipboard::Close()
{
	//close clipboard
	if(IsOpen){
		if(CloseClipboard()){
			IsOpen=false;
			return true;
		}else{
			return false;
		}
	}else{
		return false;
	}
}

bool CClipboard::Empty()
{
	//empty clipboard
	if(EmptyClipboard()){
		return true;
	}else{
		return false;
	}
}


bool CClipboard::SetText(CString &Text)
{
	bool ret(false);

	//open
	Open();

	if(IsOpen){

		int length = Text.GetLength();
		if(length>0){

			//empty clipboard
			Empty();

			LPTSTR  pText;
			HGLOBAL hMem;
			//allocate global memory for text
			hMem = GlobalAlloc(GMEM_MOVEABLE,(length+1)*sizeof(TCHAR)); 

			if (hMem!=NULL){

				//lock handle and copy text to buffer
				pText = (LPTSTR)GlobalLock(hMem);
				memcpy(pText,Text.GetBuffer(0),length*sizeof(TCHAR)); 
				pText[length] = (TCHAR)0;//null terminate
				GlobalUnlock(hMem); 

				//set clipboard text
				SetClipboardData(CF_TEXT, hMem);
				ret = true;
			}
		}
		//close clipboard
		Close();
	}
	return ret;
}

